#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <sys/shm.h>
#include <time.h>
#include <fcntl.h>
#include <sys/ipc.h>
#include "string.h"
#include "config.h"
#include <signal.h>
#include <semaphore.h>
#include <sys/sem.h>

pid_t childPID;
pid_t childPIDs[MAX_N];
int sem_id;
int shm_id;
int* shared_data;
sem_t* semaphore;

void terminateProcess(){ //Function to terminate any child processes
        for (int i = 0; i < MAX_N; i++) {
                if(childPIDs[i] > 1)
                kill(childPIDs[i], SIGTERM);
        }
}

void clean(){ //Function to deallocate shared memory and calls terminate process
terminateProcess();

shmdt(shared_data);
shmctl(shm_id, IPC_RMID, NULL);
semctl(sem_id, 0, IPC_RMID);

if (shmctl(shm_id, IPC_RMID, NULL) == -1) {
        perror("Error deallocating shared memory.");
        exit(1);
        }
        exit(0);
}


void signal_handler(int sig){ //Function to terminate on Ctrl-C
         printf("Terminated with Ctrl-C\n");
        shmdt((void *) shared_memory);
        clean();
        exit(0);
}

void alarm_handler(int arl){ //Function to terminate and clean if timer runs out
        printf("Timer ran out.\n");
        clean();
        exit(0);
}

int main(int argc, char *argv[]) {

signal(SIGINT, signal_handler);

while(1){

int n = 0;
int time = TIMEOUT;

if (argc < 2 || argc > 4){ //Command line arguments to validate user input
    printf("Command line should be formatted like %s -t ss n\n", argv[0]);
    exit(1); 
    }

if (argc >= 2 && strcmp(argv[1], "-t") == 0) {
    time = atoi(argv[2]);
}

if (argc >= 4) {
    n = atoi(argv[3]);
    if (n > MAX_N) {
        printf("n is more than 20, limiting it to 20");
        n = MAX_N;
    }
} else {
    printf("Invalid\n");
    exit(1);
}

key_t key = ftok("shmfile", 65);
shm_id  = shmget(key, sizeof(int), IPC_CREAT | 0666); //Creating shared memory

shared_data = (int*)shmat(shm_id, NULL, 0); //Allocating shared memory
*shared_data = 0;

union semun{
        int val;
        struct semid_ds *buf;
        unsigned short* array;
        struct seminfo *__buf;
}argument;

argument.val = 1;
key_t keySem = ftok("shmfile1", 65);
int sem_id = semget(keySem, 1, IPC_CREAT | IPC_EXCL | 0666);
if(sem_id == -1){
        perror("semget");
        exit(EXIT_FAILURE);
}

if (semctl(sem_id, 0, SETVAL, argument) == -1){
        perror("error with sem_id");
        exit(EXIT_FAILURE);
}

printf("Semaphore successfully made");

signal(SIGALRM, alarm_handler); //Signal for time

alarm(time);


for (int i = 0; i < n; i++){
        //char sem_name[20];
        //sprintf(sem_name, "/sem_%d", i);

/*semaphores[i] = sem_open(sem_name, O_CREAT, 0644, 1);
if(semaphores[i] == SEM_FAILED){
        perror("sem_open");
        exit(EXIT_FAILURE);
}*/
  pid_t childPID = fork();

        if (childPID == 0){
                char id_str[5];
                char pid_logical[20];
                sprintf(pid_logical, "/%s_sem", id_str);
                sprintf(pid_logical, "%d", i);
                (*shared_data)++;
                printf("hello from %d. Shared data: %d", i, *shared_data);
                execl("./slave", "./slave", pid_logical, NULL);  //Exec funtion to run slave and pass in child processes
                //sem_post(&semaphore);
                perror("exec failed");
        } else if (childPID < 0){
                perror("fork did not work");
                exit(1);
        } else {
               childPIDs[i] = childPID;
        }
}
for (int i = 0; i < n; i++){
        wait(NULL);
}

clean();

return 0;

}
}